/*# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sant�)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------ */

//=====
// Don't edit this file. This file is generated from xml description..
//=====
#include "bbcreaMaracasVisuManualPaint.h"
#include "bbcreaMaracasVisuPackage.h"

#include "ManualPaintPanel.h"
#include "ManualPaintModel.h"
#include "ManualPaintControler.h"
#include "wxManualPaintPanel.h"

#include <wx/msgdlg.h>

namespace bbcreaMaracasVisu
{


//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------


BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,ManualPaint)
BBTK_BLACK_BOX_IMPLEMENTATION(ManualPaint,bbtk::WxBlackBox);
//=====
// Don't edit this file. This file is generated from xml description..
//=====
void ManualPaint::Process()
{
printf("ManualPaint::Process start\n");


/*
   std::string msg;
    if (bbGetInputTitle()!="")
      {
	msg = bbGetInputTitle()+": " + bbGetInputIn();
      }
    else
      {
	msg = bbGetInputIn();
      }
   ((wxStaticText*)bbGetOutputWidget())->SetLabel( bbtk::std2wx( msg ) );
  */

    if (bbGetInputWxVtkBaseView1()==NULL)
    {
      wxMessageDialog(NULL,  bbtk::std2wx("(ManualPaint) Input 'WxVtkBaseView' is not set"),  bbtk::std2wx(bbGetFullName()) ).ShowModal();
    }

    if (bbGetInputIn()==NULL)
    {
      wxMessageDialog(NULL,  bbtk::std2wx("(ManualPaint) Input 'vtkImageData' is not set"),  bbtk::std2wx(bbGetFullName()) ).ShowModal();
    }


    if (firsttime==true)
    {
        firsttime=false;

        ManualPaintModel        *mpModel        = new ManualPaintModel();
        mpModel->SetImage( bbGetInputIn() );

        wxManualPaintPanel        *mpPanel        = (wxManualPaintPanel*)bbGetOutputWidget();
printf("ManualPaint::Process 1\n");
        mpPanel->SetManualPaintModel(mpModel);
printf("ManualPaint::Process 2 %p\n", mpPanel);

        if (bbGetInputWxVtkBaseView1()!=NULL)
        {
            ManualPaintControler    *mpControler    = new ManualPaintControler();
            mpControler->SetManualPaintModel(mpModel);
printf("ManualPaint::Process 3\n");
            mpControler->SetManualPaintPanel(mpPanel);
printf("ManualPaint::Process 4\n");
            mpControler->SetWxVtk2DBaseView( (wxVtk2DBaseView*)bbGetInputWxVtkBaseView1() );
printf("ManualPaint::Process 5 %p \n",bbGetInputWxVtkBaseView1() );
            mpControler->Config();
printf("ManualPaint::Process 6\n");
        }

        if (bbGetInputWxVtkBaseView2()!=NULL)
        {
printf("ManualPaint::Process 7\n");
            ManualPaintControler    *mpControler    = new ManualPaintControler();
printf("ManualPaint::Process 7.1\n");
            mpControler->SetManualPaintModel(mpModel);
printf("ManualPaint::Process 7.2\n");
            mpControler->SetManualPaintPanel(mpPanel);
printf("ManualPaint::Process 7.3\n");
            mpControler->SetWxVtk2DBaseView( (wxVtk2DBaseView*)bbGetInputWxVtkBaseView2() );
printf("ManualPaint::Process 7.4 %p\n", bbGetInputWxVtkBaseView2() );
            mpControler->Config();
printf("ManualPaint::Process 8\n");
        }

        if (bbGetInputWxVtkBaseView3()!=NULL)
        {
printf("ManualPaint::Process 9\n");
            ManualPaintControler    *mpControler    = new ManualPaintControler();
            mpControler->SetManualPaintModel(mpModel);
            mpControler->SetManualPaintPanel(mpPanel);
            mpControler->SetWxVtk2DBaseView( (wxVtk2DBaseView*)bbGetInputWxVtkBaseView3() );
            mpControler->Config();
printf("ManualPaint::Process 10\n");
        }

        if (bbGetInputWxVtkBaseView4()!=NULL)
        {
printf("ManualPaint::Process 11\n");
            ManualPaintControler    *mpControler    = new ManualPaintControler();
            mpControler->SetManualPaintModel(mpModel);
            mpControler->SetManualPaintPanel(mpPanel);
            mpControler->SetWxVtk2DBaseView( (wxVtk2DBaseView*)bbGetInputWxVtkBaseView4() );
            mpControler->Config();
printf("ManualPaint::Process 12\n");
        }
printf("ManualPaint::Process 13\n");

    }
printf("ManualPaint::Process end\n");

}
//=====
// Don't edit this file. This file is generated from xml description..
//=====
void ManualPaint::CreateWidget(wxWindow* parent)
{
   bbSetOutputWidget( new wxManualPaintPanel(parent) );
}

//=====
// Don't edit this file. This file is generated from xml description..
//=====
void ManualPaint::bbUserSetDefaultValues()
{
    firsttime=true;
    bbSetInputIn(NULL);
    bbSetInputWxVtkBaseView1(NULL);
    bbSetInputWxVtkBaseView2(NULL);
    bbSetInputWxVtkBaseView3(NULL);
    bbSetInputWxVtkBaseView4(NULL);
}
//=====
// Don't edit this file. This file is generated from xml description..
//=====
void ManualPaint::bbUserInitializeProcessing()
{

}
//=====
// Don't edit this file. This file is generated from xml description..
//=====
void ManualPaint::bbUserFinalizeProcessing()
{

}

} // EO namespace bbcreaMaracasVisu


