/*# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sant�)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------ */

/*=========================================================================

 Program:   wxMaracas
 Module:    $RCSfile: marPoint.cpp,v $
 Language:  C++
 Date:      $Date: 2012/11/15 14:15:31 $
 Version:   $Revision: 1.2 $
 
  Copyright: (c) 2002, 2003
  License:
  
   This software is distributed WITHOUT ANY WARRANTY; without even 
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
   PURPOSE.  See the above copyright notice for more information.
   
=========================================================================*/

#include "marPoint.h"

// ----------------------------------------------------------------------------
marPoint::marPoint(double x, double y) {
	this->x = x;
	this->y = y;
}

marPoint::~marPoint()
{

}

// ----------------------------------------------------------------------------
double marPoint::getX()
{
	return x;
}

// ----------------------------------------------------------------------------
double marPoint::getY()
{
	return y;
}

// ----------------------------------------------------------------------------
void marPoint::setPoint(double x, double y){
	this->x = x;
	this->y = y;
}

// ----------------------------------------------------------------------------
double marPoint::getGradient() {
	return gradient;
}

// ----------------------------------------------------------------------------
void marPoint::setGradient(double g) {
	gradient = g;
}

// ----------------------------------------------------------------------------
int marPoint::getDirection() {
	return dir;
}

// ----------------------------------------------------------------------------
bool marPoint::getInside() {
	return inside;
}

// ----------------------------------------------------------------------------
void marPoint::setDirection(int direction) {
	dir = direction;
}

// ----------------------------------------------------------------------------
void marPoint::setInside (bool ins) {
	inside = ins;
}

// ----------------------------------------------------------------------------
void marPoint::setIntensity(double intensity)
{
	this->intensity = intensity;
}

// ----------------------------------------------------------------------------
double marPoint::getIntensity()
{
	return intensity;
}

// ----------------------------------------------------------------------------
void marPoint::setType(int type)
{
	this->type = type;
}

// ----------------------------------------------------------------------------
int marPoint::getType()
{
	return type;
}

